Unit ASH4R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ASH4R(var IU :Array of Integer; var JU :Array of Integer;
                var UN :Array of Real; var DI :Array of Real;
                N :Integer; var B :Array of Real;
                var X :Array of Real);

implementation

procedure ASH4R(var IU :Array of Integer; var JU :Array of Integer;
                var UN :Array of Real; var DI :Array of Real;
                N :Integer; var B :Array of Real;
                var X :Array of Real);
var
NM,I,K,IUA,IUB,L :Integer;
XX :Real;
label
_10,_20,_30,_40,_50,_60,_70;
begin

{            }
{           - }
{      ,     }
{        RR(U)O, ..   UT*D*U*X=B. }


{   IU, JU, UN -       - }
{                  U     - }
{                 RR(U)O; }

{           DI -     N,  }
{                 ,     D; }

{            N -    (: ); }

{            B -     N,  }
{                    ; }

{            X -     N,  }
{                     }


{            Z }

NM := N-1;
for I:=1 to N do
 begin
_10:
  X[I-1] := B[I-1];
 end;

{            Z  W }
{      ( ) }

for K:=1 to NM do
 begin
  IUA := IU[K-1];
  IUB := IU[K+0]-1;
  XX := X[K-1];

{         30,     U  }

  if ( IUB < IUA ) 
   then goto _30;
  for I:=IUA to IUB do
   begin
    L := JU[I-1];
_20:
    X[L-1] := X[L-1]-UN[I-1]*XX;
   end;
_30:
  X[K-1] := XX*DI[K-1];
_40:
 end;
X[N-1] := X[N-1]*DI[N-1];

{            X (- }
{       ) }

K := NM;
_50:
IUA := IU[K-1];
IUB := IU[K+0]-1;

{         70,     U - }
{       }

if ( IUB < IUA ) 
 then goto _70;
XX := X[K-1];
for I:=IUA to IUB do
 begin
  L := JU[I-1];
_60:
  XX := XX-UN[I-1]*X[L-1];
 end;
X[K-1] := XX;
_70:
K := K-1;
if ( K > 0 ) 
 then goto _50;
end;

end.
